' HeadFile.VBS V1.08 (C) yoshioka.teruo@nifty.com 2007-06-25
' HeadFile.VBS sets file head lines to property comments.
' Usage: Start HeadFile.VBS files...

Option Explicit
Dim DSOFile
Dim fso
Dim Shell
Dim File
Dim FolderItem
Dim FileName
Dim Title
Dim Lines
Dim Line
Const N=1

Set DSOFile=CreateObject("DSOFile.OleDocumentProperties")
Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")
For Each File In WScript.Arguments
  Set File=fso.GetFile(File)
  Set FolderItem=Shell.NameSpace(File.ParentFolder.Path).Items().Item(File.Name)
  FileName=fso.GetFileName(FolderItem.Path)
  Title=Empty
  Lines=""
  Select Case(LCase(fso.GetExtensionName(FileName)))
  Case "hta"
    FolderItem.Name=FileName&".HTM"
    Lines=GetTitle(FolderItem.Path)
    Call Rename(FolderItem,FileName)
  Case "htm","html"
    Lines=GetTitle(FolderItem.Path)
  End Select
  If Lines="" Then
    Lines=Array()
    Set File=fso.OpenTextFile(FolderItem.Path,,,vbUseDefault)
    Do While Not File.AtEndOfStream
      Line=Trim(File.ReadLine())
      If Line<>"" Then
        If Not UBound(Lines)+1<N Then Exit Do
        Push Lines,Line
      End If
    Loop
    File.Close
    If UBound(Lines)+1=0 Then Exit For
    Lines=Join(Lines,vbLf)
  End If
  If FolderItem.ExtendedProperty("DocComments")<>Lines Then
    Call ChangeProperty()
  ElseIf Title="" Then
  ElseIf FolderItem.ExtendedProperty("DocTitle")<>Title Then
    Call ChangeProperty()
  End If
Next
WScript.Quit

Sub ChangeProperty()
Dim ModifyDate
ModifyDate=FolderItem.ModifyDate
DSOFile.Open(FolderItem.Path)
If Not IsEmpty(Title) Then
  DSOFile.SummaryProperties.Title=Title
End If
DSOFile.SummaryProperties.Comments=Lines
DSOFile.Save
DSOFile.Close
FolderItem.ModifyDate=ModifyDate
End Sub

Sub Rename(FolderItem,FileName)
Dim k
For k=1 To 10
  Call RenameTry(FolderItem,FileName)
  If Err=0 Then Exit For
  WScript.Sleep 200
Next
If Err<>0 Then Err.Raise Err.Number
End Sub

Sub RenameTry(FolderItem,FileName)
On Error Resume Next
FolderItem.Name=FileName
End Sub

Function GetTitle(url)
Dim ie
Dim Lines
Dim j,k
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=True
ie.Navigate2 "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.designMode="On"
ie.Navigate2 url
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
Title=Trim(ie.Document.title)
Lines=ie.Document.body.innerText
If Lines="" Then
  If ie.Document.scripts.length Then
    Lines=ie.Document.scripts(0).innerHTML
  End If
End If
ie.Quit
Do While TypeName(ie)="IWebBrowser2"
  WScript.Sleep 100
Loop
If Lines<>"" Then
  Lines=Replace(Replace(Lines,vbCrLf,vbLf),vbCr,vbLf)
  Lines=Split(Lines,vbLf)
  For j=0 To UBound(Lines)
    If Trim(Lines(j))<>"" Then
      Lines(k)=Trim(Lines(j))
      k=k+1
    End If
    If k>N Then Exit For
  Next
  If k<UBound(Lines)+1 Then ReDim Preserve Lines(k-1)
  If UBound(Lines)>N-1 Then ReDim Preserve Lines(N-1)
  Lines=Join(Lines,vbLf)
End If
GetTitle=Lines
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
