' HeadLine.VBS V1.07 (C) yoshioka.teruo@nifty.com 2007-03-24
' HeadLine.VBS sets file head lines to property comments.
' Usage: Start HeadLine.VBS files...

Option Explicit
Dim fso
Dim Shell
Dim File
Dim FolderItem
Dim FileName
Dim Title
Dim Lines
Dim Line
Dim N:N=1

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")
For Each File In WScript.Arguments
  Set File=fso.GetFile(File)
  Set FolderItem=Shell.NameSpace(File.ParentFolder.Path).Items().Item(File.Name)
  FileName=fso.GetFileName(FolderItem.Path)
  Title=Empty
  Lines=""
  Select Case(LCase(fso.GetExtensionName(FileName)))
  Case "hta"
    FolderItem.Name=FileName&".HTM"
    Lines=GetTitle(FolderItem.Path)
    Call Rename(FolderItem,FileName)
  Case "htm","html"
    Lines=GetTitle(FolderItem.Path)
  End Select
  If Lines="" Then
    Lines=Array()
    Set File=fso.OpenTextFile(FolderItem.Path,,,vbUseDefault)
    Do While Not File.AtEndOfStream
      Line=Trim(File.ReadLine())
      If Line<>"" Then
        If Not UBound(Lines)+1<N Then Exit Do
        Push Lines,Line
      End If
    Loop
    File.Close
    If UBound(Lines)+1=0 Then Exit For
    Lines=Join(Lines,vbLf)
  End If
  If FolderItem.ExtendedProperty("DocComments")<>Lines Then
    Call ChangeProperty()
  ElseIf Title="" Then
  ElseIf FolderItem.ExtendedProperty("DocTitle")<>Title Then
    Call ChangeProperty()
  End If
Next
WScript.Quit

Sub ChangeProperty()
Dim ModifyDate
Dim Path
Dim WindowsInstaller
Dim Database
Dim SummaryInformation
Dim Prop
Const adTypeBinary = 1
Const adSaveCreateOverWrite = 2
Dim Src
Dim Dst
Dim BOM
Dim Size

ModifyDate=FolderItem.ModifyDate
Path=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetTempName())
Set WindowsInstaller=CreateObject("WindowsInstaller.Installer") 
Set Database=WindowsInstaller.OpenDatabase(Path, 3) 
Set SummaryInformation=Database.SummaryInformation(16)
Prop=FolderItem.ExtendedProperty("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}1")
'WScript.Echo "CP",TypeName(Prop),Prop
Prop=FolderItem.ExtendedProperty("DocTitle")'2o
If Prop<>"" Then SummaryInformation.Property(2)=Prop
Prop=FolderItem.ExtendedProperty("DocSubject")'3o
If Prop<>"" Then SummaryInformation.Property(3)=Prop
Prop=FolderItem.ExtendedProperty("DocAuthor")'4o
If Prop<>"" Then SummaryInformation.Property(4)=Prop
Prop=FolderItem.ExtendedProperty("DocKeywords")'5x o
If Prop<>"" Then SummaryInformation.Property(5)=Prop
Prop=FolderItem.ExtendedProperty("DocComments")'6o
If Prop<>"" Then SummaryInformation.Property(6)=Prop
Prop=FolderItem.ExtendedProperty("DocRevNumber")'9x o
If Prop<>"" Then SummaryInformation.Property(9)=Prop

SummaryInformation.Property(1)=932 '&H3A4
'SummaryInformation.Property(&H80000000)=CLng(1041) '&H411
If Not IsEmpty(Title) Then
  SummaryInformation.Property(2)=Title
End If
SummaryInformation.Property(6)=Lines
SummaryInformation.Persist
Set SummaryInformation=Nothing
Database.Commit
Set Database=Nothing
Set WindowsInstaller=Nothing

'WScript.Echo  SummaryInformation.PropertyCount '16
'For k=0 To 20
'WScript.Echo  k,SummaryInformation.Property(k)
'Next
'For k=1 To 20
'Rows(k)=Join(Array(k,folderItem.ExtendedProperty("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}" & k)),vbTab)'SummaryInfo
'Next

Set Src=CreateObject("ADODB.Stream")
Set Dst=CreateObject("ADODB.Stream")
Src.Open
Dst.Open
Src.Type=adTypeBinary
Dst.Type=adTypeBinary
Src.LoadFromFile Path
On Error Resume Next
Dst.LoadFromFile FolderItem.Path&":"&Chr(5)&"SummaryInformation"
On Error GoTo 0
'WScript.Echo "StreamSize",Dst.Size
Src.Position=&HA40
BOM=Src.Read(2)
If AscB(MidB(BOM,1,1))<>&HFE Then
  WScript.Echo "BOM1",AscB(MidB(BOM,1,1))
  WScript.Quit
End If
If AscB(MidB(BOM,2,1))<>&HFF Then
  WScript.Echo "BOM2",AscB(MidB(BOM,1,1))
  WScript.Quit
End If
Src.Position=&HA40+&H30
Size=Src.Read(4)
Size=AscB(MidB(Size,1,1))+AscB(MidB(Size,2,1))*256+AscB(MidB(Size,3,1))*256*256+AscB(MidB(Size,4,1))*256*256*256+&H30
'WScript.Echo "Size",Size
Src.Position=&HA40
Src.CopyTo Dst,Size
Dst.SetEOS
Dst.SaveToFile FolderItem.Path&":"&Chr(5)&"SummaryInformation", adSaveCreateOverWrite
Src.Close
Dst.Close
Set Src = Nothing
Set Dst = Nothing

fso.DeleteFile Path
FolderItem.ModifyDate=ModifyDate
End Sub

Sub Rename(FolderItem,FileName)
Dim k
For k=1 To 10
  Call RenameTry(FolderItem,FileName)
  If Err=0 Then Exit For
  WScript.Sleep 200
Next
If Err<>0 Then Err.Raise Err.Number
End Sub

Sub RenameTry(FolderItem,FileName)
On Error Resume Next
FolderItem.Name=FileName
End Sub

Function GetTitle(url)
Dim ie
Dim Lines
Dim j,k
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=True
ie.Navigate2 "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.designMode="On"
ie.Navigate2 url
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
Title=Trim(ie.Document.title)
Lines=ie.Document.body.innerText
If Lines="" Then
  If ie.Document.scripts.length Then
    Lines=ie.Document.scripts(0).innerHTML
  End If
End If
ie.Quit
Do While TypeName(ie)="IWebBrowser2"
  WScript.Sleep 100
Loop
If Lines<>"" Then
  Lines=Replace(Replace(Lines,vbCrLf,vbLf),vbCr,vbLf)
  Lines=Split(Lines,vbLf)
  For j=0 To UBound(Lines)
    If Trim(Lines(j))<>"" Then
      Lines(k)=Trim(Lines(j))
      k=k+1
    End If
    If k>N Then Exit For
  Next
  If k<UBound(Lines)+1 Then ReDim Preserve Lines(k-1)
  If UBound(Lines)>N-1 Then ReDim Preserve Lines(N-1)
  Lines=Join(Lines,vbLf)
End If
GetTitle=Lines
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
